Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/DRWork/FrmDRWork.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/DRWork/FrmDRWork.cs	(revision 82)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/DRWork/FrmDRWork.cs	(revision 83)
@@ -314,12 +538,652 @@
         {
             if (m_bInitFlg) return;
 
-            // 担当者選択時部署選択を設定する
+            if (m_bChengeAns)
+            {
+                if (MessageBox.Show("データに変更があります、登録せずに担当者を変更しますか？。"
+                                , "担当者変更確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                {
+                    cmbConstructionPerson.SelectedIndex = cmbConstructionPerson_index;
+                    return;
+                }
+            }
             SetPerosonToDepartment();
 
+            // 変数を取り込む
+            SetVariableValue();
+
             // データ表示
-            InitDispData();
+            InitDataLoad();
+
+            // データ変更フラグクリア
+            m_bChengeAns = false;
         }
         #endregion
+
+        int comboBox1_index = -1;
+        #region 対象年月コンボボックス変更前取得
+        /// <summary>
+        /// 対象年月コンボボックス変更前取得
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void comboBox1_Enter(object sender, EventArgs e)
+        {
+            comboBox1_index = comboBox1.SelectedIndex;
+        }
+        #endregion
+
+        #region 対象年月コンボボックス変更
+        /// <summary>
+        /// 対象年月コンボボックス変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
+        {
+            if (m_bInitFlg) return;
+
+            if (m_bChengeAns)
+            {
+                if (MessageBox.Show("データに変更があります、登録せずに年月を変更しますか？。"
+                                , "対象年月変更確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.No)
+                {
+                    comboBox1.SelectedIndex = comboBox1_index;
+                    return;
+                }
+            }
+
+            // 変数を取り込む
+            SetVariableValue();
+
+            // データ表示
+            InitDataLoad();
+
+            // データ変更フラグクリア
+            m_bChengeAns = false;
+        }
+        #endregion
+
+        #region 出勤グリッドセル値の変更
+        /// <summary>
+        /// 出勤グリッドセル値の変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvAllDisplay_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            // 初期表示は処理しない
+            if (GetConstructionPersonCode() == 0) return;
+
+            // 参照時は処理しない
+            if (m_EditLock) return;
+
+            // 出勤日数・残業時間セット
+            SetWorkDaysAndOverTimes();
+
+            m_bChengeAns = true;
+        }
+        #endregion
+
+        #region 日報グリッドセル入力前処理
+        /// <summary>
+        /// 日報グリッドセル入力前処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvAllDisplay_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 参照時は処理しない
+                if (m_EditLock) return;
+
+                // データグリッドがActiveでなければ処理しない
+                if (ActiveControl == null) return;
+                if (!ActiveControl.GetType().Equals(typeof(DataGridViewEX))) return;
+
+                DataGridView dgv = (DataGridView)sender;
+
+                // 読込専用セルは処理しない
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //IMEのモードを変更する
+                switch (e.ColumnIndex)
+                {
+                    case (int)GridColumn01.ActionResult:
+                    case (int)GridColumn01.Comment:
+                        dgv.ImeMode = ImeMode.On;
+                        break;
+                    default:
+                        dgv.ImeMode = ImeMode.Disable;
+                        break;
+                }
+                // セル内容選択
+                dgv.BeginEdit(true);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 日報グリッドセル入力後処理
+        /// <summary>
+        /// 日報グリッドセル入力後処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvAllDisplay_CellValidated(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 参照時は処理しない
+                if (m_EditLock) return;
+
+                DataGridView dgv = (DataGridView)sender;
+                DataGridViewCell CurCell = dgv.CurrentCell;
+                switch (e.ColumnIndex)
+                {
+                    case (int)GridColumn01.OverTimes:
+                        // 残業時間
+                        CurCell.Value = CommonMotions.cnvDouble(CurCell.Value).ToString("0.0");
+                        break;
+                    default:
+                        break;
+                }
+                // 出勤日数・残業時間セット
+                SetWorkDaysAndOverTimes();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region タブ変更時
+        /// <summary>
+        /// タブ変更時
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
+        {
+            TabControl CurTab = (TabControl)sender;
+            switch (CurTab.SelectedIndex)
+            {
+                case 0:
+                    btnLineAdd.Visible = true;
+                    btnLineDel.Visible = true;
+                    break;
+                case 1:
+                    btnLineAdd.Visible = false;
+                    btnLineDel.Visible = false;
+                    break;
+            }
+        }
+        #endregion
+
+        #region 交通費グリッドセル入力前処理
+        /// <summary>
+        /// 交通費グリッドセル入力前処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvTransport_CellEnter(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 参照時は処理しない
+                if (m_EditLock) return;
+
+                // データグリッドがActiveでなければ処理しない
+                if (ActiveControl == null) return;
+                if (!ActiveControl.GetType().Equals(typeof(DataGridViewEX))) return;
+
+                DataGridView dgv = (DataGridView)sender;
+
+                // 読込専用セルは処理しない
+                if (dgv.CurrentCell.ReadOnly) return;
+
+                //IMEのモードを変更する
+                dgv.ImeMode = ImeMode.Disable;
+
+                // セル内容選択
+                dgv.BeginEdit(true);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 交通費グリッドセル入力後処理
+        /// <summary>
+        /// 交通費グリッドセル入力後処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvTransport_CellValidated(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 参照時は処理しない
+                if (m_EditLock) return;
+
+                DataGridView dgv = (DataGridView)sender;
+                DataGridViewRow CurRow = dgv.CurrentRow;
+                double StartDis = 0;
+                double CompDis = 0;
+                switch (e.ColumnIndex)
+                {
+                    case (int)GridColumn02.StartNumber:
+                    case (int)GridColumn02.CompNumber:
+                        // 走行距離
+                        StartDis = CommonMotions.cnvDouble(CurRow.Cells[(int)GridColumn02.StartNumber].Value);
+                        CompDis = CommonMotions.cnvDouble(CurRow.Cells[(int)GridColumn02.CompNumber].Value);
+                        CurRow.Cells[(int)GridColumn02.TotalDistance].Value = (CompDis - StartDis).ToString("0.0");
+                        break;
+                    default:
+                        break;
+                }
+                // 距離・回数再計算
+                SetDistanceAndcount();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 交通費グリッドセル値の変更
+        /// <summary>
+        /// 交通費グリッドセル値の変更
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvTransport_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 初期表示は処理しない
+                if (GetConstructionPersonCode() == 0) return;
+                
+                // 参照時は処理しない
+                if (m_EditLock) return;
+
+                // 距離・回数再計算
+                SetDistanceAndcount();
+                
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 交通費グリッド状態が変わればコミットする
+        /// <summary>
+        /// 交通費グリッド状態が変わればコミットする
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgvTransport_CurrentCellDirtyStateChanged(object sender, EventArgs e)
+        {
+            DataGridView dgv = (DataGridView)sender;
+            DataGridViewCell CurCell = dgv.CurrentCell;
+            switch (CurCell.ColumnIndex)
+            {
+                case (int)GridColumn02.OfficeGo:
+                case (int)GridColumn02.OfficeOut:
+                case (int)GridColumn02.TrancePayGo:
+                case (int)GridColumn02.TrancePayOut:
+                case (int)GridColumn02.WareHouse:
+                    //コミットする
+                    dgv.CommitEdit(DataGridViewDataErrorContexts.Commit);
+                    break;
+                default:
+                    break;
+            }
+        }
+        #endregion
+
+        #region 出勤管理状態を表示
+        /// <summary>
+        /// 出勤管理状態を表示
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnWorkingList_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                if (m_frmDRWorkList != null)
+                {
+                    m_frmDRWorkList.Activate();
+                    return;
+                }
+                // 人員数表示画面を表示
+                DispReportListControl();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 出勤管理状態をクローズ
+        /// <summary>
+        /// 出勤管理状態のクローズを取得する
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmDRWorkList_FormClosed(object sender, FormClosedEventArgs e)
+        {
+            try
+            {
+                this.Activate();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                // ハンドルクリア
+                m_frmDRWorkList.Dispose(); m_frmDRWorkList = null;
+            }
+        }
+        #endregion
+
+        #region 申請ボタン押下
+        /// <summary>
+        /// 申請ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnPetition_Click(object sender, EventArgs e)
+        {
+            IOAttendanceData AttendDB = new IOAttendanceData();
+            IOPersonApproval PersonAppDB = new IOPersonApproval();
+            try
+            {
+                // 対象月の開始終了を取得する
+                string startDate = comboBox1.SelectedValue.ToString() + "/01";
+                DateTime dtwork = CommonMotions.cnvDate(startDate);
+                int SelPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue);
+                // 日報データが無い場合は登録する
+                string strSQL = AttendDB.CreatePrimarykeyString(SelPersonCode, dtwork);
+
+                AttendanceData DataRec = new AttendanceData();
+                if (!AttendDB.SelectAction(strSQL, ref DataRec)) m_bChengeAns = true;
+
+                // データ変更有時はデータ登録
+                if (m_bChengeAns) if (!DataEntryProcess()) return;
+
+                // 起動番号
+                int NowPoint = ClsExcute.NextProcess((int)ClsExcute.SubFormExecuteNo.ApprovalPerson);
+                // 担当者コード
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(SelPersonCode);
+                // 承認機能番号
+                int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(iApprovalCode);
+                // 受付日
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(DateTime.Now);
+                // 受付番号
+                string strApp = PersonAppDB.CreatePrimarykeyString(SelPersonCode, (int)ClsExcute.ApprovalListNo.DRWorkApproval, dtwork);
+                int wrkOrderNo = PersonAppDB.SelectMaxOrderNoCount(strApp) + 1;
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(wrkOrderNo);
+
+                // 自データ検索キー
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(dtwork);
+
+                // 親フォーム終了
+                //m_ParentEnd = true;
+
+                // 終了処理OFF
+                m_CloseingProcessOn = false;
+
+                // 自フォーム終了
+                this.Close();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                AttendDB.close(); AttendDB = null;
+                PersonAppDB.close(); PersonAppDB = null;
+            }
+        }
+        #endregion
+
+        #region 承認ボタン押下
+        /// <summary>
+        /// 承認ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnApproval_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // データ変更有時はデータ登録
+                if (m_bChengeAns)
+                {
+                    if (!DataEntryProcess()) return;
+                }
+
+                // 起動番号
+                int NowPoint = ClsExcute.NextProcess((int)ClsExcute.SubFormExecuteNo.ApprovalPerson);
+
+                // 担当者コード
+                int SelPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue);
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(SelPersonCode);
+
+                // 承認機能番号
+                int iApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(iApprovalCode);
+
+                // 受付日
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(m_OrderDate);
+
+                // 受付番号
+                ClsExcute.ProcControlPara[NowPoint].IntExecParameter.Add(m_OrderNo);
+
+                // 自データ検索キー
+                string startDate = comboBox1.SelectedValue.ToString() + "/01";
+                DateTime dtwork = CommonMotions.cnvDate(startDate);
+                ClsExcute.ProcControlPara[NowPoint].DateExecParameter.Add(dtwork);
+
+                // 親フォーム終了
+                //m_ParentEnd = true;
+
+                // 終了処理OFF
+                m_CloseingProcessOn = false;
+                // 自フォーム終了
+                this.Close();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 承認パネル（pnlApproval）承認ボタン
+        /// <summary>
+        /// 承認パネル（pnlApproval）承認ボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnOnApproval_Click(object sender, EventArgs e)
+        {
+            FrmApprovalPerson frm = new FrmApprovalPerson();
+            try
+            {
+                if (MessageBox.Show("出勤管理を承認します、よろしいですか？。", "承認確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No) return;
+
+                // 担当者コード
+                int SelPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue);
+                frm.PersonCode = SelPersonCode;
+                // 承認機能番号セット
+                frm.ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 受付日
+                frm.OrderDate = m_OrderDate;
+                // 受付番号
+                frm.OrderNo = m_OrderNo;
+                // 自データ検索キー
+                string startDate = comboBox1.SelectedValue.ToString() + "/01";
+                frm.DataSearchDate =  CommonMotions.cnvDate(startDate);
+
+                // 申請・承認レコード更新
+                if (!frm.ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.Approval, false))
+                {
+                    MessageBox.Show("承認に失敗しました。", "承認エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 親フォーム終了
+                //m_ParentEnd = true;
+
+                // メニューへ戻る
+                ClsExcute.ClearProcess();
+                // 終了処理フラグOff
+                m_CloseingProcessOn = false;
+                // 画面クローズ
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 承認パネル（pnlApproval）保留ボタン
+        /// <summary>
+        /// 承認パネル（pnlApproval）保留ボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnOnHold_Click(object sender, EventArgs e)
+        {
+            FrmApprovalPerson frm = new FrmApprovalPerson();
+            try
+            {
+                if (MessageBox.Show("出勤管理を保留とします、よろしいですか？。", "保留確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No) return;
+
+                // 担当者コード
+                int SelPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue);
+                frm.PersonCode = SelPersonCode;
+                // 承認機能番号セット
+                frm.ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 受付日
+                frm.OrderDate = m_OrderDate;
+                // 受付番号
+                frm.OrderNo = m_OrderNo;
+                // 自データ検索キー
+                string startDate = comboBox1.SelectedValue.ToString() + "/01";
+                frm.DataSearchDate = CommonMotions.cnvDate(startDate);
+
+                // 申請・承認レコード更新
+                if (!frm.ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.Pending, false))
+                {
+                    MessageBox.Show("保留に失敗しました。", "保留エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 親フォーム終了
+                //m_ParentEnd = true;
+
+                // メニューへ戻る
+                ClsExcute.ClearProcess();
+                // 終了処理フラグOff
+                m_CloseingProcessOn = false;
+                // 画面クローズ
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 承認パネル（pnlApproval）不承認ボタン
+        /// <summary>
+        /// 承認パネル（pnlApproval）不承認ボタン
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnNotApproval_Click(object sender, EventArgs e)
+        {
+            FrmApprovalPerson frm = new FrmApprovalPerson();
+            try
+            {
+                if (MessageBox.Show("出勤管理を不承認します、よろしいですか？。", "不承認確認"
+                                , MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.No) return;
+
+                // 担当者コード
+                int SelPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue);
+                frm.PersonCode = SelPersonCode;
+                // 承認機能番号セット
+                frm.ApprovalCode = ClsExcute.AppovalList.First(x => x.Value.Equals(s_MyProcessName)).Key;
+                // 受付日
+                frm.OrderDate = m_OrderDate;
+                // 受付番号
+                frm.OrderNo = m_OrderNo;
+                // 自データ検索キー
+                string startDate = comboBox1.SelectedValue.ToString() + "/01";
+                frm.DataSearchDate = CommonMotions.cnvDate(startDate);
+
+                // 申請・承認レコード更新
+                if (!frm.ApprovalDataUpDate((int)CommonDefine.ApprovalStatus.NotApproval, false))
+                {
+                    MessageBox.Show("不承認に失敗しました。", "不承認エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 親フォーム終了
+                //m_ParentEnd = true;
+
+                // メニューへ戻る
+                ClsExcute.ClearProcess();
+                // 終了処理フラグOff
+                m_CloseingProcessOn = false;
+                // 画面クローズ
+                this.Close();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
     }
 }
